package com.bjsxt.servlet;

import com.bjsxt.pojo.User;
import com.fasterxml.jackson.databind.ObjectMapper;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * 通过 JSON 格式在响应中传递多个对象
 * 需求：定义一个 Users 类，包含 userid、username 属性。
 * 实例化多个 Users 对象，通过 JSON 格式将 Users 对象响应到客户端浏览器。
 * 将 Users 对象中的数据插入到页面中。
 */
@WebServlet("/multip.do")
public class MultipleObjectServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //实例化多个User
        User user1 = new User();
        user1.setUserid(1);
        user1.setUsername("zahngsan");
        User user2 = new User();
        user2.setUserid(2);
        user2.setUsername("lisi");
        //使用List集合将两个对象封装起来
        List<User> list = new ArrayList<>();
        list.add(user1);
        list.add(user2);
        //通过jackson API将list对象转换成JSON格式的字符串对象
        ObjectMapper objectMapper = new ObjectMapper();
        String s = objectMapper.writeValueAsString(list);
        //将响应类型转换为application/json类型
        resp.setContentType("application/json");
        //输出
        PrintWriter pw = resp.getWriter();
        pw.print(s);
        pw.flush();
        pw.close();
    }
}
