package com.bjsxt.servlet;

import com.bjsxt.pojo.User;
import com.fasterxml.jackson.databind.ObjectMapper;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * 通过 JSON 格式在响应中传递单个对象
 * 需求：定义一个 Users 类，包含 userid、username 属性。
 * 实例化一个 Users 对象，通过 JSON 格式将 Users 对象响应到客户端浏览器。
 * 将 Users 对象中的数据插入到页面中。
 */
@WebServlet("/single.do")
public class SingleObjectServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPut(req, resp);
    }

    @Override
    protected void doPut(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //实例化User对象
        User user = new User();
        user.setUserid(1);
        user.setUsername("username");
        //通过jackson API将User对象转换成JSON格式的字符串对象
        ObjectMapper objectMapper = new ObjectMapper();
        //将User对象转换成JSON格式的字符串对象
        String s = objectMapper.writeValueAsString(user);
        //修改响应类型为application/json类型
        resp.setContentType("application/json");
        //通过字符输出流传递给客户端
        PrintWriter out = resp.getWriter();
        out.println(s);
        out.flush();
        out.close();
    }
}
