package com.bjsxt.service.impl;

import com.bjsxt.dao.UserManagerDao;
import com.bjsxt.dao.impl.UserManagerDaoImpl;
import com.bjsxt.pojo.Users;
import com.bjsxt.service.UserManagerService;

import java.util.List;

/**
 * 用户业务层管理
 */
public class UserManagerServiceImpl implements UserManagerService {
    @Override
    public void addUser(Users user) {
        //实例化持久层
        UserManagerDao userManagerDao = new UserManagerDaoImpl();
        userManagerDao.inserUser(user);
    }

    /**
     * 查询用户的业务层
     * @param users
     * @return
     */
    @Override
    public List<Users> findUser(Users users) {
        UserManagerDao userManagerDao = new UserManagerDaoImpl();
        return  userManagerDao.selectUserByProperty(users);
    }

    /**
     * 预更新用户的业务层
     * @param userid
     * @return
     */
    @Override
    public Users findUserByUserId(int userid) {
        UserManagerDao userManagerDao = new UserManagerDaoImpl();
        return userManagerDao.selectUserByUserId(userid);
    }

    /**
     * 更新用户的业务层
     * @param users
     */
    @Override
    public void modifyUser(Users users) {
        UserManagerDao userManagerDao = new UserManagerDaoImpl();
        userManagerDao.updateUserByUserId(users);
    }

    /**
     * 删除用户的业务层
     * @param userid
     */
    @Override
    public void dropUser(int userid) {
        UserManagerDao userManagerDao = new UserManagerDaoImpl();
        userManagerDao.deleteUserByUserId(userid);
    }
}
